Index: projets/BCCCC/src/org/ccc/bcccc/client/areas/DataRecordArea.java
===================================================================
--- projets/BCCCC/src/org/ccc/bcccc/client/areas/DataRecordArea.java	(revision 5)
+++ projets/BCCCC/src/org/ccc/bcccc/client/areas/DataRecordArea.java	(revision 6)
@@ -21,8 +21,8 @@
 import java.util.ArrayList;
 import java.util.List;
 
-import org.ccc.bcccc.client.ViewAndEditTerrainRecordPanel;
 import org.ccc.bcccc.client.areas.fields.DataRecordField;
+import org.ccc.bcccc.client.panels.EditPanel;
 import org.ccc.bcccc.shared.Data;
 
 import com.smartgwt.client.widgets.Label;
@@ -43,7 +43,7 @@
 	 * @param panel the panel
 	 * @param name the name
 	 */
-	public DataRecordArea(ViewAndEditTerrainRecordPanel panel, String name) {
+	public DataRecordArea(EditPanel panel, String name) {
 		//super(panel, name, true, false, Data.values);
 		//form.setNumCols(7); // show 3 item per line
 		this.setWidth100();
Index: projets/BCCCC/src/org/ccc/bcccc/client/areas/DateRecordArea.java
===================================================================
--- projets/BCCCC/src/org/ccc/bcccc/client/areas/DateRecordArea.java	(revision 5)
+++ projets/BCCCC/src/org/ccc/bcccc/client/areas/DateRecordArea.java	(revision 6)
@@ -20,7 +20,7 @@
 
 import java.util.Date;
 
-import org.ccc.bcccc.client.ViewAndEditTerrainRecordPanel;
+import org.ccc.bcccc.client.panels.EditPanel;
 
 import com.smartgwt.client.widgets.form.fields.DateItem;
 import com.smartgwt.client.widgets.form.fields.FormItem;
@@ -44,7 +44,7 @@
 	 * @param freeField the free field
 	 * @param values the values
 	 */
-	public DateRecordArea(ViewAndEditTerrainRecordPanel panel, String name, boolean multiple, boolean freeField,
+	public DateRecordArea(EditPanel panel, String name, boolean multiple, boolean freeField,
 			String[] values) {
 		super(panel, name, multiple, freeField, values);
 	}
Index: projets/BCCCC/src/org/ccc/bcccc/client/areas/ReportsRecordArea.java
===================================================================
--- projets/BCCCC/src/org/ccc/bcccc/client/areas/ReportsRecordArea.java	(revision 5)
+++ projets/BCCCC/src/org/ccc/bcccc/client/areas/ReportsRecordArea.java	(revision 6)
@@ -21,8 +21,8 @@
 import java.util.ArrayList;
 import java.util.List;
 
-import org.ccc.bcccc.client.ViewAndEditTerrainRecordPanel;
 import org.ccc.bcccc.client.areas.fields.ReportRecordField;
+import org.ccc.bcccc.client.panels.EditPanel;
 import org.ccc.bcccc.shared.Report;
 
 import com.smartgwt.client.widgets.Label;
@@ -43,7 +43,7 @@
 	 * @param panel the panel
 	 * @param name the name
 	 */
-	public ReportsRecordArea(ViewAndEditTerrainRecordPanel panel, String name) {
+	public ReportsRecordArea(EditPanel panel, String name) {
 		this.setWidth100();
 		
 		Label title = new Label();
Index: projets/BCCCC/src/org/ccc/bcccc/client/areas/fields/DocumentRecordField.java
===================================================================
--- projets/BCCCC/src/org/ccc/bcccc/client/areas/fields/DocumentRecordField.java	(revision 0)
+++ projets/BCCCC/src/org/ccc/bcccc/client/areas/fields/DocumentRecordField.java	(revision 6)
@@ -0,0 +1,169 @@
+/*
+ * Authors: Matthieu Decorde
+ * 
+ * COPYRIGHT 2015 ICAR - CCC
+ * 
+ * This software is free software: you can redistribute it 
+ * and/or modify it under the terms of the GNU General Public
+ * License as published by the Free Software Foundation,
+ * either version 2 of the License, or (at your option) any
+ * later version.
+ * 
+ * This software is distributed in the hope that it will be
+ * useful, but WITHOUT ANY WARRANTY; without even the implied
+ * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
+ * PURPOSE. See the GNU General Public License for more
+ * details.
+ * 
+ */
+package org.ccc.bcccc.client.areas.fields;
+
+import org.ccc.bcccc.client.areas.DispositifsRecordArea;
+import org.ccc.bcccc.client.areas.DocumentsRecordArea;
+import org.ccc.bcccc.shared.Dispositif;
+import org.ccc.bcccc.shared.DocumentUnit;
+
+import com.smartgwt.client.util.SC;
+import com.smartgwt.client.util.ValueCallback;
+import com.smartgwt.client.widgets.form.DynamicForm;
+import com.smartgwt.client.widgets.form.fields.ButtonItem;
+import com.smartgwt.client.widgets.form.fields.CheckboxItem;
+import com.smartgwt.client.widgets.form.fields.PickerIcon;
+import com.smartgwt.client.widgets.form.fields.PickerIcon.Picker;
+import com.smartgwt.client.widgets.form.fields.SelectItem;
+import com.smartgwt.client.widgets.form.fields.StaticTextItem;
+import com.smartgwt.client.widgets.form.fields.events.ClickEvent;
+import com.smartgwt.client.widgets.form.fields.events.ClickHandler;
+import com.smartgwt.client.widgets.form.fields.events.FormItemClickHandler;
+import com.smartgwt.client.widgets.form.fields.events.FormItemIconClickEvent;
+
+// TODO: Auto-generated Javadoc
+/**
+ * The Class DispositifsRecordField.
+ */
+public class DocumentRecordField extends DynamicForm {
+	
+	/** The r. */
+	DocumentUnit r = new DocumentUnit("","","");
+	
+	/** The area. */
+	DocumentsRecordArea area;
+	
+	/** The n. */
+	int n;
+	
+	/** The name field. */
+	StaticTextItem nameItem;
+	
+	/** The url field. */
+	StaticTextItem urlField;
+	
+	/** The type field. */
+	SelectItem typeField;
+	
+	/**
+	 * Instantiates a new dispositifs record field.
+	 *
+	 * @param area the area
+	 * @param n the n
+	 */
+	public DocumentRecordField(DocumentsRecordArea area, int n) {
+		
+		this.area = area;
+		this.n = n;
+		this.setNumCols(8);
+		
+		nameItem = new StaticTextItem("docname"+(n));
+		nameItem.setTitle("Name");
+		Picker EDIT = new Picker("pickers/edit.png");
+		PickerIcon nameEditPicker = new PickerIcon(EDIT, new FormItemClickHandler() {  
+			public void onFormItemClick(FormItemIconClickEvent event) { 
+				SC.askforValue("Enter the new value of Name of the document", new ValueCallback() {
+					@Override
+					public void execute(String value) {
+						if (value != null) {
+							nameItem.setValue(value);
+						}
+					}
+				});
+			}  
+		});
+		nameItem.setIcons(nameEditPicker);
+		
+		typeField = new SelectItem("doctype"+(n));
+		typeField.setValueMap(DocumentUnit.values);
+		typeField.setTitle("Type");
+		
+		urlField = new StaticTextItem("docurl"+(n));
+		urlField.setTitle("URL");
+		PickerIcon urlEditPicker = new PickerIcon(EDIT, new FormItemClickHandler() {  
+			public void onFormItemClick(FormItemIconClickEvent event) { 
+				SC.askforValue("Enter the new value of URL of the document", new ValueCallback() {
+					@Override
+					public void execute(String value) {
+						if (value != null) {
+							urlField.setValue(value);
+						}
+					}
+				});
+
+			}  
+		});
+		urlField.setIcons(urlEditPicker);
+
+		ButtonItem addButton = new ButtonItem("dispadd"+n);
+		addButton.setTitle("+");
+		addButton.setStartRow(false);
+		addButton.setEndRow(false);
+
+		ButtonItem removeButton = new ButtonItem("dispremove"+n);
+		removeButton.setTitle("-");
+		removeButton.setStartRow(false);
+		removeButton.setEndRow(false);
+
+		addButton.addClickHandler(new ClickHandler() {
+			@Override
+			public void onClick(ClickEvent event) {
+				DocumentRecordField.this.area.addAField();
+			}
+		});
+
+		removeButton.addClickHandler(new ClickHandler() {
+			@Override
+			public void onClick(ClickEvent event) {
+				DocumentRecordField.this.area.remove(DocumentRecordField.this);
+			}
+		});
+
+		this.setItems(nameItem, typeField, urlField, removeButton, addButton);
+
+	}
+	
+	/**
+	 * Sets the value.
+	 *
+	 * @param r the new value
+	 */
+	public void setValue(DocumentUnit r) {
+		typeField.setValue(r.type);
+		urlField.setValue(r.url);
+		nameItem.setValue(r.name);
+	}
+	
+	/**
+	 * Gets the value.
+	 *
+	 * @return the value
+	 */
+	public DocumentUnit getValue() {
+		r.type = typeField.getValueAsString();
+		Object o = urlField.getValue();
+		if (o != null) r.url = urlField.getValue().toString();
+		else r.url = "";
+		
+		o = nameItem.getValue();
+		if (o != null)  r.name = nameItem.getValue().toString();
+		r.name = "";
+		return r;
+	}
+}

Index: projets/BCCCC/src/org/ccc/bcccc/client/areas/fields/DispositifsRecordField.java
===================================================================
--- projets/BCCCC/src/org/ccc/bcccc/client/areas/fields/DispositifsRecordField.java	(revision 5)
+++ projets/BCCCC/src/org/ccc/bcccc/client/areas/fields/DispositifsRecordField.java	(revision 6)
@@ -19,9 +19,7 @@
 package org.ccc.bcccc.client.areas.fields;
 
 import org.ccc.bcccc.client.areas.DispositifsRecordArea;
-import org.ccc.bcccc.client.areas.ReportsRecordArea;
 import org.ccc.bcccc.shared.Dispositif;
-import org.ccc.bcccc.shared.Report;
 
 import com.smartgwt.client.util.SC;
 import com.smartgwt.client.util.ValueCallback;
@@ -29,9 +27,9 @@
 import com.smartgwt.client.widgets.form.fields.ButtonItem;
 import com.smartgwt.client.widgets.form.fields.CheckboxItem;
 import com.smartgwt.client.widgets.form.fields.PickerIcon;
+import com.smartgwt.client.widgets.form.fields.PickerIcon.Picker;
 import com.smartgwt.client.widgets.form.fields.SelectItem;
-import com.smartgwt.client.widgets.form.fields.TextItem;
-import com.smartgwt.client.widgets.form.fields.PickerIcon.Picker;
+import com.smartgwt.client.widgets.form.fields.StaticTextItem;
 import com.smartgwt.client.widgets.form.fields.events.ClickEvent;
 import com.smartgwt.client.widgets.form.fields.events.ClickHandler;
 import com.smartgwt.client.widgets.form.fields.events.FormItemClickHandler;
@@ -56,7 +54,7 @@
 	SelectItem typeField;
 	
 	/** The url field. */
-	TextItem urlField;
+	StaticTextItem urlField;
 	
 	/** The mobile item. */
 	CheckboxItem mobileItem;
@@ -71,13 +69,13 @@
 		
 		this.area = area;
 		this.n = n;
-		this.setNumCols(7);
+		this.setNumCols(8);
 		
 		typeField = new SelectItem("dispname"+(n));
 		typeField.setValueMap(Dispositif.types);
-		typeField.setShowTitle(false);
+		typeField.setTitle("Type");
 
-		urlField = new TextItem("dispurl"+(n));
+		urlField = new StaticTextItem("dispurl"+(n));
 		urlField.setTitle("URL");
 		Picker EDIT = new Picker("pickers/edit.png");
 		PickerIcon urlEditPicker = new PickerIcon(EDIT, new FormItemClickHandler() {  
@@ -143,8 +141,10 @@
 	 * @return the value
 	 */
 	public Dispositif getValue() {
-		r.type = typeField.getValue().toString();
-		r.url = urlField.getValue().toString();
+		r.type = typeField.getValueAsString();
+		Object o = urlField.getValue();
+		if (o != null) r.url = urlField.getValue().toString();
+		else r.url = "";
 		r.mobile = mobileItem.getValueAsBoolean();
 		return r;
 	}
Index: projets/BCCCC/src/org/ccc/bcccc/client/areas/fields/DataRecordField.java
===================================================================
--- projets/BCCCC/src/org/ccc/bcccc/client/areas/fields/DataRecordField.java	(revision 5)
+++ projets/BCCCC/src/org/ccc/bcccc/client/areas/fields/DataRecordField.java	(revision 6)
@@ -69,7 +69,7 @@
 		
 		typeField = new SelectItem("datatype"+(n));
 		typeField.setValueMap(Data.values);
-		typeField.setShowTitle(false);
+		typeField.setTitle("Type");
 
 		urlField = new StaticTextItem("dataurl"+(n));
 		urlField.setTitle("URL");
@@ -82,7 +82,8 @@
 		
 		Picker EDIT = new Picker("pickers/edit.png");
 		PickerIcon urlEditPicker = new PickerIcon(EDIT, new FormItemClickHandler() {  
-			public void onFormItemClick(FormItemIconClickEvent event) { 
+			@Override
+			public void onFormItemClick(FormItemIconClickEvent event) {
 				SC.askforValue("Enter the new value of URL of Data", new ValueCallback() {
 					@Override
 					public void execute(String value) {
@@ -91,7 +92,6 @@
 						}
 					}
 				});
-
 			}  
 		});
 		urlField.setIcons(urlEditPicker);
@@ -140,7 +140,11 @@
 	 */
 	public Data getValue() {
 		d.type = typeField.getValueAsString();
-		d.url = urlField.getValue().toString();
+		
+		Object o = urlField.getValue();
+		if (o != null) d.url = urlField.getValue().toString();
+		else d.url = "";
+		
 		return d;
 	}
 }
Index: projets/BCCCC/src/org/ccc/bcccc/client/areas/fields/ReportRecordField.java
===================================================================
--- projets/BCCCC/src/org/ccc/bcccc/client/areas/fields/ReportRecordField.java	(revision 5)
+++ projets/BCCCC/src/org/ccc/bcccc/client/areas/fields/ReportRecordField.java	(revision 6)
@@ -29,6 +29,7 @@
 import com.smartgwt.client.widgets.form.fields.PickerIcon.Picker;
 import com.smartgwt.client.widgets.form.fields.SpinnerItem;
 import com.smartgwt.client.widgets.form.fields.StaticTextItem;
+import com.smartgwt.client.widgets.form.fields.TextAreaItem;
 import com.smartgwt.client.widgets.form.fields.events.ClickEvent;
 import com.smartgwt.client.widgets.form.fields.events.ClickHandler;
 import com.smartgwt.client.widgets.form.fields.events.FormItemClickHandler;
@@ -50,10 +51,10 @@
 	int n;
 	
 	/** The user item. */
-	StaticTextItem userItem;
+	StaticTextItem userField;
 	
 	/** The comment item. */
-	StaticTextItem commentItem;
+	TextAreaItem commentField;
 	
 	/** The note field. */
 	SpinnerItem noteField;
@@ -68,27 +69,28 @@
 
 		this.area = area;
 		this.n = n;
-		this.setNumCols(7);
+		this.setNumCols(8);
 		
-		userItem = new StaticTextItem("reportuser"+(n));
-		userItem.setShowTitle(false);
+		Picker EDIT = new Picker("pickers/edit.png");
 
-		commentItem = new StaticTextItem("reportcomment"+(n));
-		commentItem.setTitle("");
-		Picker EDIT = new Picker("pickers/edit.png");
+		userField = new StaticTextItem("reportuser"+(n));
+		userField.setTitle("User");
+				
+		commentField = new TextAreaItem("reportcomment"+(n));
+		commentField.setTitle("Comment");
 		PickerIcon nameEditPicker = new PickerIcon(EDIT, new FormItemClickHandler() {  
 			public void onFormItemClick(FormItemIconClickEvent event) { 
 				SC.askforValue("Enter the comment", new ValueCallback() {
 					@Override
 					public void execute(String value) {
 						if (value != null) {
-							commentItem.setValue(value);
+							commentField.setValue(value);
 						}
 					}
 				});
 			}  
 		});
-		commentItem.setIcons(nameEditPicker);
+		commentField.setIcons(nameEditPicker);
 
 		noteField = new SpinnerItem("reportnote"+(n));
 		noteField.setTitle("Note");
@@ -120,7 +122,7 @@
 			}
 		});
 		
-		this.setFields(userItem, commentItem, noteField, removeButton, addButton);
+		this.setFields(userField, commentField, noteField, removeButton, addButton);
 	}
 	
 	/**
@@ -129,8 +131,8 @@
 	 * @param r the new value
 	 */
 	public void setValue(Report r) {
-		userItem.setValue(r.user);
-		commentItem.setValue(r.comment);
+		userField.setValue(r.user);
+		commentField.setValue(r.comment);
 		noteField.setValue(r.note);
 	}
 	
@@ -140,8 +142,15 @@
 	 * @return the value
 	 */
 	public Report getValue() {
-		r.user = userItem.getValue().toString();
-		r.comment = commentItem.getValue().toString();
+		
+		Object o = userField.getValue();
+		if (o != null) r.user = userField.getValue().toString();
+		else r.user = "";
+
+		o = commentField.getValue();
+		if (o != null) r.comment = commentField.getValue().toString();
+		else r.comment = "";
+		
 		r.note = Integer.parseInt(noteField.getValueAsString());
 		return r;
 	}
Index: projets/BCCCC/src/org/ccc/bcccc/client/areas/DispositifsRecordArea.java
===================================================================
--- projets/BCCCC/src/org/ccc/bcccc/client/areas/DispositifsRecordArea.java	(revision 5)
+++ projets/BCCCC/src/org/ccc/bcccc/client/areas/DispositifsRecordArea.java	(revision 6)
@@ -21,9 +21,9 @@
 import java.util.ArrayList;
 import java.util.List;
 
-import org.ccc.bcccc.client.ViewAndEditTerrainRecordPanel;
 import org.ccc.bcccc.client.areas.fields.DispositifsRecordField;
 import org.ccc.bcccc.client.areas.fields.ReportRecordField;
+import org.ccc.bcccc.client.panels.EditPanel;
 import org.ccc.bcccc.shared.Dispositif;
 
 import com.smartgwt.client.util.SC;
@@ -57,7 +57,7 @@
 	 * @param panel the panel
 	 * @param name the name
 	 */
-	public DispositifsRecordArea(ViewAndEditTerrainRecordPanel panel, String name) {
+	public DispositifsRecordArea(EditPanel panel, String name) {
 		this.setWidth100();
 		
 		Label title = new Label();
Index: projets/BCCCC/src/org/ccc/bcccc/client/areas/StringRecordField.java
===================================================================
--- projets/BCCCC/src/org/ccc/bcccc/client/areas/StringRecordField.java	(revision 5)
+++ projets/BCCCC/src/org/ccc/bcccc/client/areas/StringRecordField.java	(revision 6)
@@ -21,7 +21,7 @@
 import java.util.ArrayList;
 import java.util.List;
 
-import org.ccc.bcccc.client.ViewAndEditTerrainRecordPanel;
+import org.ccc.bcccc.client.panels.EditPanel;
 
 import com.google.gwt.user.client.ui.Label;
 import com.smartgwt.client.types.TitleOrientation;
@@ -66,7 +66,7 @@
 	ArrayList<FormItem> items = new ArrayList<FormItem>();
 	
 	/** The panel. */
-	protected ViewAndEditTerrainRecordPanel panel;
+	protected EditPanel panel;
 	
 	/** The form. */
 	DynamicForm form;
@@ -80,7 +80,7 @@
 	 * @param freeField the free field
 	 * @param values the values
 	 */
-	public StringRecordField(ViewAndEditTerrainRecordPanel panel, String name, boolean multiple, boolean freeField, String[] values) {
+	public StringRecordField(EditPanel panel, String name, boolean multiple, boolean freeField, String[] values) {
 		this.panel = panel;
 		this.name = name;
 		this.multiple = multiple;
Index: projets/BCCCC/src/org/ccc/bcccc/client/areas/LongStringRecordArea.java
===================================================================
--- projets/BCCCC/src/org/ccc/bcccc/client/areas/LongStringRecordArea.java	(revision 5)
+++ projets/BCCCC/src/org/ccc/bcccc/client/areas/LongStringRecordArea.java	(revision 6)
@@ -18,7 +18,7 @@
  */
 package org.ccc.bcccc.client.areas;
 
-import org.ccc.bcccc.client.ViewAndEditTerrainRecordPanel;
+import org.ccc.bcccc.client.panels.EditPanel;
 
 import com.smartgwt.client.widgets.form.fields.FormItem;
 import com.smartgwt.client.widgets.form.fields.TextAreaItem;
@@ -41,7 +41,7 @@
 	 * @param multiple the multiple
 	 * @param freeField the free field
 	 */
-	public LongStringRecordArea(ViewAndEditTerrainRecordPanel panel, String name, boolean multiple, boolean freeField) {
+	public LongStringRecordArea(EditPanel panel, String name, boolean multiple, boolean freeField) {
 		super(panel, name, multiple, freeField, null);
 	}
 
Index: projets/BCCCC/src/org/ccc/bcccc/client/BCCCC.java
===================================================================
--- projets/BCCCC/src/org/ccc/bcccc/client/BCCCC.java	(revision 5)
+++ projets/BCCCC/src/org/ccc/bcccc/client/BCCCC.java	(revision 6)
@@ -20,6 +20,12 @@
 
 import java.util.ArrayList;
 
+import org.ccc.bcccc.client.panels.BrowsePanel;
+import org.ccc.bcccc.client.panels.CreatePanel;
+import org.ccc.bcccc.client.panels.EditPanel;
+import org.ccc.bcccc.client.panels.HomePanel;
+import org.ccc.bcccc.client.panels.SearchPanel;
+import org.ccc.bcccc.client.panels.ViewPanel;
 import org.ccc.bcccc.shared.K;
 import org.ccc.bcccc.shared.TerrainRecord;
 import org.ccc.bcccc.shared.TerrainRecordAndRights;
@@ -61,12 +67,15 @@
 	SearchPanel searchPanel = new SearchPanel();
 	
 	/** The create terrain record panel. */
-	CreateTerrainRecordPanel createTerrainRecordPanel = new CreateTerrainRecordPanel();
+	CreatePanel createTerrainRecordPanel = new CreatePanel();
 	
-	/** The terrain record panel. */
-	ViewAndEditTerrainRecordPanel terrainRecordPanel = new ViewAndEditTerrainRecordPanel();
+	/** The edit terrain record panel. */
+	EditPanel editTerrainRecordPanel = new EditPanel();
+	
+	/** The view terrain record panel. */
+	ViewPanel viewTerrainRecordPanel = new ViewPanel();
 
-	/** The main bar. */
+	/** The main Toolbar. */
 	ToolStrip mainBar = new ToolStrip();
 	
 	/** The center layout. */
@@ -111,7 +120,7 @@
 	/** The user name label. */
 	private Label userNameLabel;
 
-	/** The continue history change. */
+	/** The continue history change: indicate if the history change must be interrupted */
 	boolean continueHistoryChange = true;
 
 	/** The lw. */
@@ -143,7 +152,6 @@
 	 * Initialize UI.
 	 */
 	public void init() {
-
 		History.newItem(""); // reset history
 		homePanel.init();
 		mainLayout.setWidth100();
@@ -263,7 +271,7 @@
 
 				continueHistoryChange = true;
 				for (Canvas panel : centerLayout.getMembers()){
-					if (panel == terrainRecordPanel && terrainRecordPanel.isRecordChanged()) {
+					if (panel == editTerrainRecordPanel && editTerrainRecordPanel.isRecordChanged()) {
 						SC.ask("Warning: the record is not saved. Continue ?", new BooleanCallback() {
 							@Override
 							public void execute(Boolean value) {
@@ -340,7 +348,7 @@
 				} else if (hist.startsWith(K.NEWRECORD)) {
 					createTerrainRecordPanel.init();
 					centerLayout.addMember(createTerrainRecordPanel);
-				} else if (hist.startsWith(K.VIEWEDITRECORD)) {
+				} else if (hist.startsWith(K.EDITRECORD)) {
 					int idx = hist.indexOf("_") + 1;
 					if (idx > 0) { // the URL contains the record ID
 						String id = hist.substring(idx);
@@ -356,17 +364,44 @@
 								if (result != null) {
 									doubleClickedRecord = result.record;
 
-									terrainRecordPanel.init();
-									centerLayout.addMember(terrainRecordPanel);
+									editTerrainRecordPanel.init();
+									centerLayout.addMember(editTerrainRecordPanel);
 								} else {
 									SC.warn("No record found with id="+long_id);
 								}
 							}
 						});
 					} else {
-						terrainRecordPanel.init();
-						centerLayout.addMember(terrainRecordPanel);
+						editTerrainRecordPanel.init();
+						centerLayout.addMember(editTerrainRecordPanel);
 					}
+				}  else if (hist.startsWith(K.VIEWRECORD)) {
+					int idx = hist.indexOf("_") + 1;
+					if (idx > 0) { // the URL contains the record ID
+						String id = hist.substring(idx);
+						final long long_id = Long.parseLong(id);
+						Services.getMain().getRecord(long_id, new AsyncCallback<TerrainRecordAndRights>() {
+							@Override
+							public void onFailure(Throwable caught) {
+								SC.warn("Error while fetching record with id="+long_id+": "+caught);
+							}
+
+							@Override
+							public void onSuccess(TerrainRecordAndRights result) {
+								if (result != null) {
+									doubleClickedRecord = result.record;
+
+									viewTerrainRecordPanel.init();
+									centerLayout.addMember(viewTerrainRecordPanel);
+								} else {
+									SC.warn("No record found with id="+long_id);
+								}
+							}
+						});
+					} else {
+						viewTerrainRecordPanel.init();
+						centerLayout.addMember(viewTerrainRecordPanel);
+					}
 				} else {
 					homePanel.init();
 					centerLayout.addMember(homePanel);
